require_relative '../lib/svn.rb'
require 'rake'

describe Svn do
	it "should be able to obtain lastest revision" do
		Dir.mktmpdir{|dir|
			#{}`svnadmin create svn_test_repo 2>&1`
			#expect(File.exists?("#{dir}/svn_test_repo"))
			#svn_repo="file:///#{dir}/svn_test_repo"
			#{}`svn checkout #{svn_repo} trunk`

			#FileUtils.rm_r('svn_test_repo')
		}		
	end

	it "should be able to detect changes" do
		FileUtils.mkdir('tmp') if(!File.exists?('tmp'))
		FileUtils.mkdir('tmp/svn_test') if(!File.exists?('tmp/svn_test'))

		svn_repo="file:///#{Rake.application.original_dir}/tmp/svn_test/change_repo"
		Dir.chdir('tmp/svn_test') do
			FileUtils.rm_r('change_repo') if File.exists?('change_repo')

			`svnadmin create change_repo 2>&1`
			`svn checkout #{svn_repo} ctrunk`
			File.open('ctrunk/file1.txt','w'){|f|f.write('abc')}
			Dir.chdir('ctrunk') do
				`svn add file1.txt`
				`svn commit -m'all'`
				expect(Svn.has_changes?).to eq(false)
				File.open('file1.txt','w'){|f|f.write('def')}
				expect(Svn.has_changes?).to eq(true)
				`svn commit -m'all'`
			end
			FileUtils.rm_r 'ctrunk'
			FileUtils.rm_r 'change_repo'
		end		
	end

	it "should be able to publish files to a subversion repository" do

		FileUtils.mkdir('tmp') if(!File.exists?('tmp'))
		FileUtils.mkdir('tmp/svn_test') if(!File.exists?('tmp/svn_test'))

		svn_repo="file:///#{Rake.application.original_dir}/tmp/svn_test/svn_test_repo"
		Dir.chdir('tmp/svn_test') do
			FileUtils.rm_r('svn_test_repo') if File.exists?('svn_test_repo')

			`svnadmin create svn_test_repo 2>&1`
			expect(File.exists?('svn_test_repo')).to eq(true)
			expect(File.exists?("#{Rake.application.original_dir}/tmp/svn_test/svn_test_repo")).to eq(true)

			FileUtils.rm_r('to_publish') if(File.exists?('to_publish'))
			FileUtils.mkdir('to_publish') if(!File.exists?('to_publish'))
			File.open('to_publish/file1.txt','w'){|f|f.write('abc')}
			File.open('to_publish/file2.txt','w'){|f|f.write('def')}
			File.open('to_publish/file3.text','w'){|f|f.write('ghi')}
			File.open('to_publish/file4.dat','w'){|f|f.write('jkl')}

			svn_dest="#{svn_repo}/to_publish"
			Svn.publish "#{Rake.application.original_dir}/tmp/svn_test/to_publish", svn_dest, ['*.txt','*.dat']
			expect(`svn info #{svn_dest}`.include?('Revision:')).to eq(true)
			puts `svn info #{svn_dest}/file1.txt`
			expect(`svn info #{svn_dest}/file1.txt`.include?('Revision:')).to eq(true)
			expect(`svn info #{svn_dest}/file2.txt`.include?('Revision:')).to eq(true)
			expect(`svn info #{svn_dest}/file3.text 2>&1`.include?('Revision:')).to eq(false)
			expect(`svn info #{svn_dest}/file4.dat 2>&1`.include?('Revision:')).to eq(true)

			FileUtils.rm_r('to_publish')
			expect(File.exists?('to_publish')).to eq(false)
			FileUtils.rm_r('svn_test_repo')
			expect(File.exists?('svn_test_repo')).to eq(false)
		end
		
		FileUtils.rm_r('tmp/svn_test')
	end
end